//
//  MyStatistics.h
//  Gamepedia
//
//  Created by Conor Dearden on 12/12/05.
//  Copyright 2005 Chiguire LLC. All rights reserved.
//

#import <Cocoa/Cocoa.h>

enum {
	MKStatisticCount = 1,
	MKStatisticCommaCount,
	MKStatisticListDate,
	MKStatisticRelationshipCount,
	MKStatisticRelationshipName,
	MKStatisticSaved,  // also total entries
		// All these below need totalEntries value and no countArray 
	MKStatisticPercentage,
	MKStatisticDuration,
	MKStatisticMyRating,
	MKStatisticPages,
    MKStatisticRelationshipCountDate,
	//MKStatisticStatus,
	//MKStatisticHeader = 20,
};


@interface MyStatistics : NSObject {
	NSString *fieldIdentifier;
	NSString *title;
	NSMutableArray *countArray;
	NSMutableDictionary *countDict;
	NSUInteger type, totalEntries;
	NSUInteger percentageCount, percentageCount1, percentageCount2, percentageCount3, percentageCount4, percentageCount5, percentageCount6, percentageCount7, percentageCount8, percentageCount9, percentageCount10;
	NSString *percentageEqual;
	BOOL forExport;
    BOOL sortByLabel;
    BOOL descending;
}

@property (assign, nonatomic) BOOL sortByLabel;
@property (assign, nonatomic) BOOL descending;


+ (NSArray *)configurationArray;


- (id)initWithField:(NSString *)aField title:(NSString *)aTitle type:(int)aType;
- (void)processEntry:(MOEntry *)anEntry;
- (void)appendHTMLTo:(NSMutableString *)htmlString;

- (void)setEqualTo:(NSString *)equalString;
- (void)setTotalEntries:(NSUInteger)totalNumber;
- (void)setForExport:(BOOL)aBool;

- (void)statCount:(id)aString;
- (void)statListDate:(NSDate *)dateValue title:(NSString *)title;
- (void)statListNumber:(NSInteger)intValue title:(NSString *)title;

- (void)appendBarHTMLTo:(NSMutableString *)htmlString;
- (void)appendListHTMLTo:(NSMutableString *)htmlString;
- (void)percentageHTMLFor:(NSString *)entryTitle count:(NSUInteger)count total:(NSUInteger)total to:(NSMutableString *)htmlString;

- (void)sortTwoObjectArray;
//+ (void)sortTwoObjectArrayFieldName:(NSMutableArray *)array;

//+ (void)appendHTMLHeader:(NSMutableString *)aMutableString export:(BOOL)forExport;
//+ (void)appendHTMLFooter:(NSMutableString *)aMutableString export:(BOOL)forExport;

- (void)appendTitleHeader:(NSString *)aTitle to:(NSMutableString *)htmlString;

+ (NSString *)titleOrIdentifierForStat:(NSDictionary *)anEntry;
+ (void)closeBoxIfNecessary:(NSMutableString *)htmlString;

@end
